### Hierarchy

- Httpified
- Stream
  - Request

## Index

### Properties

- agent
- body
- ca
- callback
- cert
- dests
- elapsedTime
- encoding
- explicitMethod
- followAllRedirects
- followOriginalHttpMethod
- gzip
- har
- headers
- host
- href
- key
- localAddress
- maxRedirects
- method
- passphrase
- path
- pool
- port
- postambleCRLF
- preambleCRLF
- proxy
- readable
- rejectUnauthorized
- removeRefererHeader
- response
- setHost
- src
- startTime
- startTimeNow
- strictSSL
- time
- timeout
- timing
- timings
- tunnel
- uri
- withCredentials
- writable
- defaultMaxListeners

### Methods

- abort
- addListener
- auth
- aws
- debug
- destroy
- emit
- end
- eventNames
- form
- getHeader
- getMaxListeners
- hasHeader
- hawk
- jar
- json
- listenerCount
- listeners
- multipart
- oauth
- off
- on
- once
- pause
- pipe
- pipeDest
- prependListener
- prependOnceListener
- qs
- rawListeners
- removeAllListeners
- removeHeader
- removeListener
- resume
- setHeader
- setMaxListeners
- toJSON
- write
- listenerCount

## Properties

### agent

agent: false | Agent | Agent

- Defined in node_modules/@types/request/index.d.ts:289

### body

body: Buffer | Buffer[] | string | string[] | stream.Readable

- Defined in node_modules/@types/request/index.d.ts:290

### Optional ca

ca: string | Buffer | string[] | Buffer[]

- Defined in node_modules/@types/request/index.d.ts:275

### Optional callback

callback: RequestCallback

- Defined in node_modules/@types/request/index.d.ts:283

### Optional cert

cert: Buffer

- Defined in node_modules/@types/request/index.d.ts:273

### dests

dests: stream.Readable[]

- Defined in node_modules/@types/request/index.d.ts:282

### Optional elapsedTime

elapsedTime: undefined | number

- Defined in node_modules/@types/request/index.d.ts:307

### Optional encoding

encoding: string | null

- Defined in node_modules/@types/request/index.d.ts:262

### Optional explicitMethod

explicitMethod: undefined | true

- Defined in node_modules/@types/request/index.d.ts:219

### Optional followAllRedirects

followAllRedirects: undefined | false | true

- Defined in node_modules/@types/request/index.d.ts:258

### Optional followOriginalHttpMethod

followOriginalHttpMethod: undefined | false | true

- Defined in node_modules/@types/request/index.d.ts:259

### Optional gzip

gzip: undefined | false | true

- Defined in node_modules/@types/request/index.d.ts:268

### Optional har

har: HttpArchiveRequest

- Defined in node_modules/@types/request/index.d.ts:276

### headers

headers: Headers

Overrides Httpified.headers

- Defined in node_modules/@types/request/index.d.ts:279

### Optional host

host: undefined | string

- Defined in node_modules/@types/request/index.d.ts:256

### href

href: string

- Defined in node_modules/@types/request/index.d.ts:295

### Optional key

key: Buffer

- Defined in node_modules/@types/request/index.d.ts:272

### Optional localAddress

localAddress: undefined | string

- Defined in node_modules/@types/request/index.d.ts:264

### Optional maxRedirects

maxRedirects: undefined | number

- Defined in node_modules/@types/request/index.d.ts:260

### method

method: string

- Defined in node_modules/@types/request/index.d.ts:280

### Optional passphrase

passphrase: undefined | string

- Defined in node_modules/@types/request/index.d.ts:274

### path

path: string

- Defined in node_modules/@types/request/index.d.ts:288

### pool

pool: false | object

- Defined in node_modules/@types/request/index.d.ts:281

### Optional port

port: undefined | number

- Defined in node_modules/@types/request/index.d.ts:257

### Optional postambleCRLF

postambleCRLF: undefined | false | true

- Defined in node_modules/@types/request/index.d.ts:270

### Optional preambleCRLF

preambleCRLF: undefined | false | true

- Defined in node_modules/@types/request/index.d.ts:269

### proxy

proxy: null | string | Url

- Defined in node_modules/@types/request/index.d.ts:285

### readable

readable: boolean

- Defined in node_modules/@types/request/index.d.ts:217

### Optional rejectUnauthorized

rejectUnauthorized: undefined | false | true

- Defined in node_modules/@types/request/index.d.ts:266

### Optional removeRefererHeader

removeRefererHeader: undefined | false | true

- Defined in node_modules/@types/request/index.d.ts:261

### Optional response

response: Response

- Defined in node_modules/@types/request/index.d.ts:308

### setHost

setHost: boolean

- Defined in node_modules/@types/request/index.d.ts:287

### Optional src

src: stream.Readable

- Defined in node_modules/@types/request/index.d.ts:292

### Optional startTime

startTime: undefined | number

- Defined in node_modules/@types/request/index.d.ts:296

### Optional startTimeNow

startTimeNow: undefined | number

- Defined in node_modules/@types/request/index.d.ts:297

### Optional strictSSL

strictSSL: undefined | false | true

- Defined in node_modules/@types/request/index.d.ts:265

### Optional time

time: undefined | false | true

- Defined in node_modules/@types/request/index.d.ts:267

### Optional timeout

timeout: undefined | number

- Defined in node_modules/@types/request/index.d.ts:263

### Optional timing

timing: undefined | false | true

- Defined in node_modules/@types/request/index.d.ts:291

### Optional timings

timings: undefined | object

- Defined in node_modules/@types/request/index.d.ts:298

### tunnel

tunnel: boolean

- Defined in node_modules/@types/request/index.d.ts:286

### uri

uri: Url & object

- Defined in node_modules/@types/request/index.d.ts:284

### Optional withCredentials

withCredentials: undefined | false | true

- Defined in node_modules/@types/request/index.d.ts:271

### writable

writable: boolean

- Defined in node_modules/@types/request/index.d.ts:218

### Static defaultMaxListeners

defaultMaxListeners: number

Inherited from EventEmitter.defaultMaxListeners

- Defined in node_modules/@types/node/events.d.ts:8

## Methods

### abort

- abort(): void

- - Defined in node_modules/@types/request/index.d.ts:251

  #### Returns void

### addListener

- addListener(event: string | symbol, listener: function): this

- Inherited from EventEmitter.addListener

  Overrides EventEmitter.addListener

  - Defined in node_modules/@types/node/events.d.ts:10

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: function

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns this

### auth

- auth(username: string, password: string, sendImmediately?: undefined | false | true, bearer?: undefined | string): Request

- - Defined in node_modules/@types/request/index.d.ts:230

  #### Parameters

  - ##### username: string

  - ##### password: string

  - ##### Optional sendImmediately: undefined | false | true

  - ##### Optional bearer: undefined | string

  #### Returns Request

### aws

- aws(opts: AWSOptions, now?: undefined | false | true): Request

- - Defined in node_modules/@types/request/index.d.ts:228

  #### Parameters

  - ##### opts: AWSOptions

  - ##### Optional now: undefined | false | true

  #### Returns Request

### debug

- debug(...args: any[]): void

- - Defined in node_modules/@types/request/index.d.ts:221

  #### Parameters

  - ##### Rest ...args: any[]

  #### Returns void

### destroy

- destroy(): void

- - Defined in node_modules/@types/request/index.d.ts:252

  #### Returns void

### emit

- emit(event: string | symbol, ...args: any[]): boolean

- Inherited from EventEmitter.emit

  Overrides EventEmitter.emit

  - Defined in node_modules/@types/node/events.d.ts:22

  #### Parameters

  - ##### event: string | symbol

  - ##### Rest ...args: any[]

  #### Returns boolean

### end

- end(cb?: undefined | function): void
- end(chunk: string | Buffer, cb?: undefined | function): void
- end(str: string, encoding?: undefined | string, cb?: undefined | function): void

- - Defined in node_modules/@types/request/index.d.ts:245

  #### Parameters

  - ##### Optional cb: undefined | function

  #### Returns void

- - Defined in node_modules/@types/request/index.d.ts:246

  #### Parameters

  - ##### chunk: string | Buffer

  - ##### Optional cb: undefined | function

  #### Returns void

- - Defined in node_modules/@types/request/index.d.ts:247

  #### Parameters

  - ##### str: string

  - ##### Optional encoding: undefined | string

  - ##### Optional cb: undefined | function

  #### Returns void

### eventNames

- eventNames(): Array<string | symbol>

- Inherited from EventEmitter.eventNames

  Overrides EventEmitter.eventNames

  - Defined in node_modules/@types/node/events.d.ts:23

  #### Returns Array<string | symbol>

### form

- form(): FormData
- form(form: any): Request

- - Defined in node_modules/@types/request/index.d.ts:224

  #### Returns FormData

- - Defined in node_modules/@types/request/index.d.ts:225

  #### Parameters

  - ##### form: any

  #### Returns Request

### getHeader

- getHeader(name: KeyType): ValueType | undefined

- Inherited from Httpified.getHeader

  - Defined in node_modules/@types/caseless/index.d.ts:26

  #### Parameters

  - ##### name: KeyType

  #### Returns ValueType | undefined

### getMaxListeners

- getMaxListeners(): number

- Inherited from EventEmitter.getMaxListeners

  Overrides EventEmitter.getMaxListeners

  - Defined in node_modules/@types/node/events.d.ts:19

  #### Returns number

### hasHeader

- hasHeader(name: KeyType): KeyType | false

- Inherited from Httpified.hasHeader

  - Defined in node_modules/@types/caseless/index.d.ts:25

  #### Parameters

  - ##### name: KeyType

  #### Returns KeyType | false

### hawk

- hawk(opts: HawkOptions): void

- - Defined in node_modules/@types/request/index.d.ts:229

  #### Parameters

  - ##### opts: HawkOptions

  #### Returns void

### jar

- jar(jar: CookieJar): Request

- - Defined in node_modules/@types/request/index.d.ts:232

  #### Parameters

  - ##### jar: CookieJar

  #### Returns Request

### json

- json(val: any): Request

- - Defined in node_modules/@types/request/index.d.ts:227

  #### Parameters

  - ##### val: any

  #### Returns Request

### listenerCount

- listenerCount(type: string | symbol): number

- Inherited from EventEmitter.listenerCount

  Overrides EventEmitter.listenerCount

  - Defined in node_modules/@types/node/events.d.ts:24

  #### Parameters

  - ##### type: string | symbol

  #### Returns number

### listeners

- listeners(event: string | symbol): Function[]

- Inherited from EventEmitter.listeners

  Overrides EventEmitter.listeners

  - Defined in node_modules/@types/node/events.d.ts:20

  #### Parameters

  - ##### event: string | symbol

  #### Returns Function[]

### multipart

- multipart(multipart: RequestPart[]): Request

- - Defined in node_modules/@types/request/index.d.ts:226

  #### Parameters

  - ##### multipart: RequestPart[]

  #### Returns Request

### oauth

- oauth(oauth: OAuthOptions): Request

- - Defined in node_modules/@types/request/index.d.ts:231

  #### Parameters

  - ##### oauth: OAuthOptions

  #### Returns Request

### off

- off(event: string | symbol, listener: function): this

- Inherited from EventEmitter.off

  Overrides EventEmitter.off

  - Defined in node_modules/@types/node/events.d.ts:16

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: function

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns this

### on

- on(event: string, listener: function): this
- on(event: "request", listener: function): this
- on(event: "response", listener: function): this
- on(event: "data", listener: function): this
- on(event: "error", listener: function): this
- on(event: "complete", listener: function): this
- on(event: "pipe", listener: function): this
- on(event: "socket", listener: function): this

- Overrides EventEmitter.on

  - Defined in node_modules/@types/request/index.d.ts:234

  #### Parameters

  - ##### event: string

  - ##### listener: function

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns this

- Overrides EventEmitter.on

  - Defined in node_modules/@types/request/index.d.ts:235

  #### Parameters

  - ##### event: "request"

  - ##### listener: function

    - - (req: ClientRequest): void

      - #### Parameters

        - ##### req: ClientRequest

        #### Returns void

  #### Returns this

- Overrides EventEmitter.on

  - Defined in node_modules/@types/request/index.d.ts:236

  #### Parameters

  - ##### event: "response"

  - ##### listener: function

    - - (resp: Response): void

      - #### Parameters

        - ##### resp: Response

        #### Returns void

  #### Returns this

- Overrides EventEmitter.on

  - Defined in node_modules/@types/request/index.d.ts:237

  #### Parameters

  - ##### event: "data"

  - ##### listener: function

    - - (data: Buffer | string): void

      - #### Parameters

        - ##### data: Buffer | string

        #### Returns void

  #### Returns this

- Overrides EventEmitter.on

  - Defined in node_modules/@types/request/index.d.ts:238

  #### Parameters

  - ##### event: "error"

  - ##### listener: function

    - - (e: Error): void

      - #### Parameters

        - ##### e: Error

        #### Returns void

  #### Returns this

- Overrides EventEmitter.on

  - Defined in node_modules/@types/request/index.d.ts:239

  #### Parameters

  - ##### event: "complete"

  - ##### listener: function

    - - (resp: Response, body?: string | Buffer): void

      - #### Parameters

        - ##### resp: Response

        - ##### Optional body: string | Buffer

        #### Returns void

  #### Returns this

- Overrides EventEmitter.on

  - Defined in node_modules/@types/request/index.d.ts:240

  #### Parameters

  - ##### event: "pipe"

  - ##### listener: function

    - - (src: stream.Readable): void

      - #### Parameters

        - ##### src: stream.Readable

        #### Returns void

  #### Returns this

- Overrides EventEmitter.on

  - Defined in node_modules/@types/request/index.d.ts:241

  #### Parameters

  - ##### event: "socket"

  - ##### listener: function

    - - (src: Socket): void

      - #### Parameters

        - ##### src: Socket

        #### Returns void

  #### Returns this

### once

- once(event: string | symbol, listener: function): this

- Inherited from EventEmitter.once

  Overrides EventEmitter.once

  - Defined in node_modules/@types/node/events.d.ts:12

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: function

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns this

### pause

- pause(): void

- - Defined in node_modules/@types/request/index.d.ts:249

  #### Returns void

### pipe

- pipe<T>(destination: T, options?: undefined | object): T

- Inherited from internal.pipe

  - Defined in node_modules/@types/node/stream.d.ts:5

  #### Type parameters

  - #### T: WritableStream

  #### Parameters

  - ##### destination: T

  - ##### Optional options: undefined | object

  #### Returns T

### pipeDest

- pipeDest(dest: any): void

- - Defined in node_modules/@types/request/index.d.ts:222

  #### Parameters

  - ##### dest: any

  #### Returns void

### prependListener

- prependListener(event: string | symbol, listener: function): this

- Inherited from EventEmitter.prependListener

  Overrides EventEmitter.prependListener

  - Defined in node_modules/@types/node/events.d.ts:13

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: function

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns this

### prependOnceListener

- prependOnceListener(event: string | symbol, listener: function): this

- Inherited from EventEmitter.prependOnceListener

  Overrides EventEmitter.prependOnceListener

  - Defined in node_modules/@types/node/events.d.ts:14

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: function

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns this

### qs

- qs(q: object, clobber?: undefined | false | true): Request

- - Defined in node_modules/@types/request/index.d.ts:223

  #### Parameters

  - ##### q: object

  - ##### Optional clobber: undefined | false | true

  #### Returns Request

### rawListeners

- rawListeners(event: string | symbol): Function[]

- Inherited from EventEmitter.rawListeners

  Overrides EventEmitter.rawListeners

  - Defined in node_modules/@types/node/events.d.ts:21

  #### Parameters

  - ##### event: string | symbol

  #### Returns Function[]

### removeAllListeners

- removeAllListeners(event?: string | symbol): this

- Inherited from EventEmitter.removeAllListeners

  Overrides EventEmitter.removeAllListeners

  - Defined in node_modules/@types/node/events.d.ts:17

  #### Parameters

  - ##### Optional event: string | symbol

  #### Returns this

### removeHeader

- removeHeader(name: KeyType): boolean

- Inherited from Httpified.removeHeader

  - Defined in node_modules/@types/caseless/index.d.ts:27

  #### Parameters

  - ##### name: KeyType

  #### Returns boolean

### removeListener

- removeListener(event: string | symbol, listener: function): this

- Inherited from EventEmitter.removeListener

  Overrides EventEmitter.removeListener

  - Defined in node_modules/@types/node/events.d.ts:15

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: function

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns this

### resume

- resume(): void

- - Defined in node_modules/@types/request/index.d.ts:250

  #### Returns void

### setHeader

- setHeader(name: KeyType, value: ValueType, clobber?: undefined | false | true): KeyType | false
- setHeader(dict: RawDict): void

- Inherited from Httpified.setHeader

  - Defined in node_modules/@types/caseless/index.d.ts:23

  #### Parameters

  - ##### name: KeyType

  - ##### value: ValueType

  - ##### Optional clobber: undefined | false | true

  #### Returns KeyType | false

- Inherited from Httpified.setHeader

  - Defined in node_modules/@types/caseless/index.d.ts:24

  #### Parameters

  - ##### dict: RawDict

  #### Returns void

### setMaxListeners

- setMaxListeners(n: number): this

- Inherited from EventEmitter.setMaxListeners

  Overrides EventEmitter.setMaxListeners

  - Defined in node_modules/@types/node/events.d.ts:18

  #### Parameters

  - ##### n: number

  #### Returns this

### toJSON

- toJSON(): RequestAsJSON

- - Defined in node_modules/@types/request/index.d.ts:253

  #### Returns RequestAsJSON

### write

- write(buffer: Buffer | string, cb?: undefined | function): boolean
- write(str: string, encoding?: undefined | string, cb?: undefined | function): boolean

- - Defined in node_modules/@types/request/index.d.ts:243

  #### Parameters

  - ##### buffer: Buffer | string

  - ##### Optional cb: undefined | function

  #### Returns boolean

- - Defined in node_modules/@types/request/index.d.ts:244

  #### Parameters

  - ##### str: string

  - ##### Optional encoding: undefined | string

  - ##### Optional cb: undefined | function

  #### Returns boolean

### Static listenerCount

- listenerCount(emitter: EventEmitter, event: string | symbol): number

- Inherited from EventEmitter.listenerCount

  - Defined in node_modules/@types/node/events.d.ts:7
  deprecated

    since v4.0.0

  #### Parameters

  - ##### emitter: EventEmitter

  - ##### event: string | symbol

  #### Returns number

Generated using TypeDoc